Smart Proxy - Feature #2595

Expose more existing rubyipmi features as BMC smart-proxy APIs

05/30/2013 02:48 PM - Konstantin Orekhov

Status: Closed

Priority: Normal

Assignee: Konstantin Orekhov
Category: BMC

Target version:

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/smart-pro

xy/pull/505,

https://github.com/theforeman/smart-pro

xy/pull/521
Description

Additional BMC features in smart-proxy to expose already existing ones in rubyipmi/ipmitool (0.5.1)

- fru list

- bmc info

- power reset

- sel

- bmc ip source (dhcp/static)

- bmc reset <cold|warm> (this one needs to be added to rubyipmi library first, https:/github.com/logicminds/rubyipmi/issues/4)

I'll be working on the above and submit a pull request.

Associated revisions

Revision a9332b68 - 05/05/2017 09:51 AM - Nick L.
Fixes #2595 - Add more Rubyipmi methods to BMC API

Replaces: theforeman/smart-proxy#505

Replaces: 051b285aaa9b595ea9513ff5fa197eb830b942¢1

This commit implements the same features as

051b285aaa9b595ea9513ff5fa197eb830b942¢1, with some differences:

— Added unit tests for all new features

— Added interfaces to "modules/bmc/base.rb’

- Cleared up some ambiguous method names

— Changed some unit test stubs to expects

- Fixed bugs in the original implementation

New AP| methods:
- GET /bmc/:host/fru
Shows available actions: "list",

and "asset_tag"

- GET /bmc/:host/bmc
Shows available actions: "info",

- GET /bmc/:host/sensors
Shows available actions: "list",

"templist", and "get"

- GET /bmc/:host/lan/snmp
"serial",

"guid",

"count",

"manufacturer", "model",

and "version"

"names",

"fanlist",
https://github.com/logicminds/rubyipmi/issues/4

Shows BMC host's SNMP community string

- GET /bmc/:host/lan/vlanid
Shows BMC host's VLAN ID

- GET /bmc/:host/lan/ipsrc
Shows whether BMC host's LAN was configured "static" or "dhcp"

- GET /bmc/:host/lan/print
Shows BMC hosts's LAN configuration

- PUT /bmc/:host/chassis/power/reset
Performs power reset on chassis

- GET /bmc/:host/fru/list
Shows all of host's FRU information. Includes workaround for
undocumented IBM/Lenovo IPMI bug.

- GET /bmc/:host/fru/serial
Shows host's serial number

- GET /bmc/:host/fru/manufacturer
Shows host's manufacturer

- GET /bmc/:host/fru/model
Shows host's product model

- GET /bmc/:host/fru/asset_tag
Shows host's asset tag string, if Rubyipmi has this method. It's in
the spec, but doesn't seem to be implemented today. See
logicminds/rubyipmi/blob/master/spec/unit/ipmitool/fru_spec.rb

- GET /bmc/:host/bmc/info
Shows information about the BMC

- GET /bmc/:host/bmc/guid
Shows system's GUID

- GET /bmc/:host/version
Shows BMC's version

- PUT /bmc/:host/bmc/reset?type=warm
Performs warm reset on BMC

- PUT /bmc/:host/bmc/reset?type=cold
Performs cold reset on BMC

- GET /bmc/:host/sensors/list
Shows all of host's sensors

- GET /bmc/:host/sensors/count
Shows number of sensors on host

- GET /bmc/:host/sensors/names
Shows list of sensor names on host

- GET /bmc/:host/sensors/fanlist
Shows all of host's fan sensors

- GET /bmc/:host/sensors/templist
Shows all of host's temperature sensors

- GET /bmc/:host/sensors/get
Shows available option "sensor" for this action

- GET /bmc/:host/sensors/get/:sensor
Shows information about sensor :sensor on host

History

#1 - 05/31/2013 04:05 AM - Dominic Cleal
- Category set to BMC
- Status changed from New to Assigned

- Assignee set to Konstantin Orekhov
#2 - 06/26/2013 03:03 PM - Konstantin Orekhov

Submitted another enhancement request to add SEL (system event log) feature to rubyipmi - https:/github.com/logicminds/rubyipmi/issues/6
in addition to https://github.com/logicminds/rubyipmi/issues/7 to add "sensors/get <sensor name>".

#3 - 03/20/2015 01:47 PM - Corey Osman

- Description updated

| think this could be achieved by using the forwardable pattern or using @conn as a delegate to expose all the commands to the BMC ipmi class.

https://github.com/theforeman/smart-proxy/blob/develop/modules/bmc/ipmi.rb

It would be a lot of refactoring but definitely worth it since all Rubyipmi commands would be exposed automatically which we could probably write a
smart enough BMC API call to run virtually any command and return 501 if its not implemented.

#4 - 02/03/2017 05:31 PM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/smart-proxy/pull/505 added

#5 - 04/20/2017 02:10 PM - The Foreman Bot
- Pull request https://github.com/theforeman/smart-proxy/pull/521 added

#6 - 05/05/2017 10:01 AM - Nick L.
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset a9332b68542b3a4473cd1ce84c8740c093e21f3a.

#7 - 08/28/2017 08:13 PM - Konstantin Orekhov

Nick Liu wrote:

Applied in changeset a9332b68542b3a4473cd1ce84c8740c093e21f3a.

Is this feature released? If so, which version of Foreman this is included in?

#8 - 08/29/2017 01:20 AM - Marek Hulan

This added new API endpoints to Foreman proxy. Based on date, | think it is in 1.15. | don't see any change in Foreman that would use it.
#9 - 08/29/2017 03:40 AM - Nick L.
Konstantin Orekhov wrote:

Nick Liu wrote:

Applied in changeset a9332b68542b3a4473cd1ce84c8740c093e21f3a.

Is this feature released? If so, which version of Foreman this is included in?

These new APl methods were introduced in Smart Proxy 1.16. Foreman 1.16, however, does not use any of these new APl methods.
